"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const moment_1 = __importDefault(require("moment"));
const mp3Regex = /\[([0-9]{4}\.[0-9]{2}\.[0-9]{2})\]\s+(.+)\s+-\s+(.+)\.mp3/;
const dateRegex = /[0-9]{4}\.[0-9]{2}\.[0-9]{2}/;
const datePattern = "YYYY.MM.DD";
class Mp3 {
    constructor(url) {
        this.url = url;
        const splitMp3 = decodeURIComponent(url).split("/");
        const filename = splitMp3[splitMp3.length - 1] || "";
        const mp3Match = filename.match(mp3Regex);
        this.filename = filename;
        if (mp3Match !== null && mp3Match[1] && mp3Match[2] && mp3Match[3]) {
            this.date = moment_1.default(mp3Match[1], datePattern);
            this.show = mp3Match[2];
            this.artist = mp3Match[3];
        }
        else {
            let filedate = filename.match(dateRegex);
            this.date = filedate === null ? null : moment_1.default(filedate[0], datePattern);
        }
    }
    static create(url) {
        return new Mp3(url);
    }
    // You typically don't want to be calling any of these methods, they're
    // mostly for debugging
    toString() {
        return JSON.stringify(this.valueOf());
    }
    toJSONString() {
        return this.toString();
    }
    valueOf() {
        return {
            url: this.url,
            filename: this.filename,
            date: this.date,
            show: this.show,
            artist: this.artist,
        };
    }
}
exports.default = Mp3;
//# sourceMappingURL=Mp3.js.map